import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/*
 * ChatClient.java
 *
 * Created on 2. Mrz 2007, 17:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Christian Ramann
 */
public class ChatClient {
    
    private Frame f;
    private TextArea output;
    private TextField input;
    private Panel p;
    private Button bsend, bquit;
    private Choice names;
    private MenuBar mb;
    private Menu m1;
    private Menu m2;
    private MenuItem mi1;
    private MenuItem mi2;
    private Socket s = null;
    private BufferedReader serverIn = null;
    private PrintStream serverOut = null;
        
    public ChatClient() {
        f = new Frame("Chat Room");
        output = new TextArea();
        input = new TextField();
        p = new Panel();
        bsend = new Button("Send");
        bquit = new Button("Quit");
        names = new Choice();
        mb = new MenuBar();
        m1 = new Menu("File");
        m2 = new Menu("Help");
        mi1 = new MenuItem("Quit");
        mi2 = new MenuItem("About");
    }
    
    public void launchChat() {
        // Frame-Layout setzen
        f.setLayout(new BorderLayout());
        f.setSize(600,300);
        // Textinput und -output ins Frame einfgen
        f.add(output, BorderLayout.CENTER);
        // ActionListener anfgen
        input.addActionListener(new SendHandler());
        f.add(input, BorderLayout.SOUTH);
        // Panel erstellen
        p.setLayout(new GridLayout(3,1));
        bquit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
        bsend.addActionListener(new SendHandler());
        names.add("Christian Ramann");
        names.add("Grand Poobah");
        names.add("Java Geck");
        p.add(bsend);
        p.add(bquit);
        p.add(names);
        f.addWindowListener(new CloseHandler());
        f.add(p, BorderLayout.EAST);
        mi1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                exit();
            }
        });
        mi2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                final Dialog about = new Dialog(f, "About");
                about.setSize(300, 300);
                TextArea text = new TextArea();
                text.setText("Programm erstellt von " + "\n" 
                           + "Christian Ramann" + "\n"
                           + "Hofgartenstr. 7" + "\n"
                           + "83527 Haag" + "\n"
                           + "+49 (0) 80 72 - 95 91 75" + "\n"
                           + " Germany");
                text.setEditable(false);
                about.add(text);
                about.addWindowListener(new WindowAdapter() {
                    public void windowClosing(WindowEvent w) {
                        about.setVisible(false);
                    }
                });
                about.setVisible(true);
            }
        });
        m1.add(mi1);
        m2.add(mi2);
        mb.add(m1);
        mb.setHelpMenu(m2);
        f.setMenuBar(mb);
        f.pack();
        f.setVisible(true);
        
        doConnect();
    }
    
    public static void main(String[] args) {
        ChatClient c = new ChatClient();
        c.launchChat();
    }
    
    private class CloseHandler extends WindowAdapter {
        public void windowClosing(WindowEvent w) {
            exit();
        }
    }
    
    private class SendHandler implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            String text = input.getText();
            text = names.getSelectedItem() + ": " + text + "\n";
            serverOut.print(text);
            input.setText("");
        }
    }
    
    private void doConnect() {
        String serverIp = System.getProperty("serverIP", "127.0.0.1");
        String serverPort = System.getProperty("serverPort", "2000");
        
        try {
            s = new Socket(serverIp, Integer.parseInt(serverPort));
            InputStream is = s.getInputStream();
            InputStreamReader isr = new InputStreamReader(is);
            serverIn = new BufferedReader(isr);
            
            serverOut = new PrintStream(s.getOutputStream());
            
            Thread t = new Thread(new RemoteReader());
            
            t.start();
        } catch (Exception e) {
            System.err.println("Unable to connect to server!");
            e.printStackTrace();
        }
    }
    
    private void exit() {
        try {
            s.close();
        } catch (Exception e) {
            System.err.println("Error while shutting down the server connection.");
        }
        System.exit(0);
    }    
    
    private class RemoteReader implements Runnable {
        public void run() {
            try {
                while (true) {
                    String nextLine = serverIn.readLine();
                    output.append(nextLine + "\n");
                }
            } catch (Exception e) {
                System.err.println("Unable to connect to server!");
                e.printStackTrace();
            }
        }
    }
}